/* 
    ADSINC.H -
    
    This file:

        To forward declare common ADS objects and to faciliate        
        the compilation, if pre-compiled headers are used.

    (C) Copyright 1988-1994 by Autodesk, Inc.

    This program is copyrighted by Autodesk, Inc. and is  licensed
    to you under the following conditions.  You may not distribute
    or  publish the source code of this program in any form.   You
    may  incorporate this code in object form in derivative  works
    provided  such  derivative  works  are  (i.) are  designed and
    intended  to  work  solely  with  Autodesk, Inc. products, and
    (ii.)  contain  Autodesk's  copyright  notice  "(C)  Copyright
    1988-1994 by Autodesk, Inc."

    AUTODESK  PROVIDES THIS PROGRAM "AS IS" AND WITH  ALL  FAULTS.
    AUTODESK  SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF  MER-
    CHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK,  INC.
    DOES  NOT  WARRANT THAT THE OPERATION OF THE PROGRAM  WILL  BE
    UNINTERRUPTED OR ERROR FREE.

*/
#ifndef __ADSINC_H
#define __ADSINC_H

#include <windows.h>
#include  <stdio.h>
#include <iostream.h>
#include  "adslib.h"

#ifdef __cplusplus
extern "C"{
#endif

int ads_winit(HINSTANCE hinst, char *progname);

#ifdef __cplusplus
}
#endif

#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#ifndef ASSERT
#include <assert.h>
#define ASSERT assert
#endif

//-----------------------------------------------------------------------------
// ADSCPP.H:
//
struct      ADS_FUNC;
struct      ADS_FUNC_INFO;
class       ADS_APP;


//-----------------------------------------------------------------------------
// ADSSTRNG_H
//
class       ADS_REFERENCE;
class       STRING_REF;
struct      ADS_STRING;

//-----------------------------------------------------------------------------
// ADSDXF.H
//
struct      DXF_GROUP_INFO;

//-----------------------------------------------------------------------------
// ADSENT.H
//
struct      ADS_ENT_OBJ;
struct      ADS_GENERIC_ENTITY;
struct      ADS_LINE;
struct      ADS_CIRCLE;
struct      ADS_SHAPE;
struct      ADS_POINT;

//-----------------------------------------------------------------------------
// ADSOBJ.H
//
struct      ADS_OBJ;

//-----------------------------------------------------------------------------
// ADSTABLE.H
//
struct      ADS_TABLE_OBJ;
struct      ADS_LAYER;
struct      ADS_LTYPE;
struct      ADS_VIEW;
struct      ADS_STYLE;
struct      ADS_BLOCK;
struct      ADS_UCS;
struct      ADS_DIMSTYLE;
struct      ADS_VPORT;
struct      ADS_APPID;

//-----------------------------------------------------------------------------
#include "cppstuff.h"
#include "adsobj.h"
#include "adsstrng.h"
#include "adsmisc.h"
#include "adsdxf.h"
#include "adsent.h"
#include "adstable.h"

#endif
