/***************************************************************************/
/*  GLOBAL TYPEDEFS  */
/**************************************************************************/
typedef struct node {               /*  BTREE NODE STRUCTURE  */
   struct node     *l;              /*  left node pointer  */
   struct node     *r;              /*  right node pointer  */
   struct node     *p;              /*  pointer to parent of node  */
   char            *key;            /*  key for record  */
   struct {
	   unsigned    ltag    : 1;     /*  left pointer is thread = on  */
	   unsigned    rtag    : 1;     /*  right pointer is thread = on  */
	   unsigned    delete  : 1;     /*  deleted node  */
	   unsigned    unused  : 5;     /*  unused bits  */
		   } flags;
				   } nodetype;

typedef struct list {               /*  BTREE SET STRUCTURE  */
   struct list     *next;           /*  next pointer  */
   nodetype        *node;           /*  node pointer  */
				   } listtype;

