/**************************************************************************/
/*  GLOBAL DEFINES  */
/**************************************************************************/

#define LLL_STORE_END          'E'  /*  store type end  */
#define LLL_STORE_HEAD         'H'  /*  store type head  */


/**************************************************************************/
/*  GLOBAL TYPEDEFS  */
/**************************************************************************/

typedef struct lll {                /* LINKED LIST STRUCTURE */
                    struct lll *next; /*  forward pointer */
                    char *data;       /*  data for linked list */
                   } llltype;


/**************************************************************************/
/*  GLOBAL FUNCTIONS  */
/**************************************************************************/

char           *lll_alloc_node();   /*  node allocation function  */
int            lll_delete_node();   /*  node deletion function  */
int            lll_free_node();     /*  node free function  */
int            lll_store_node();    /*  node store function  */
char           *malloc();           /*  memory alloc function  */
void           free();              /*  memory free function  */
