/*****************************************************************************
   Module Name : sdk.h              sdk_src_general_sdk.h

   Description : General include file for ALL sdk programs

   Author:  Tools and Technologies Group
            Autodesk, Inc.
            Software Developers' Kit
   
   (c) Copyright 1989,1990, 1991 by Autodesk Inc.
   ***************************************************************************
      Permission to use, copy, modify, and distribute this software and its
      documentation for the purpose of creating applications for AutoCAD, is
      hereby granted in accordance with the terms of the License Agreement
      accompanying this product.
   ***************************************************************************

      AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. AUTODESK 
      SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY OR
      FITNESS FOR A PARTICULAR USE. AUTODESK, INC. DOES NOT WARRANT THAT
      THE OPERATION OF THE PROGRAM WILL BE UNINTERRUPTED OR ERROR FREE.

   ***************************************************************************
                           RESTRICTED RIGHTS LEGEND 

      Use, duplication, or disclosure by the U.S. Government is subject 
      to restrictions set forth in FAR 52.227-19 (Commerical Computer
      Software - Restricted Rights) and DFAR 252.227-7013 (c) (1) (ii)
      (Rights in Technical Data and Computer Software), as applicable.
   ***************************************************************************

   Modification History:

   Notes and restrictions on use:
       This file should contain NO system dependent definitions.  It is
       designed to be included in all SDK programs and utilities that are
       written by Autodesk.  All general definitions, typedefs and global
       data which are used by tools written by Autodesk as part of SDK
       should be included in this file.  Data which is program, module, 
       or function specific should not be included here.  Users should
       include this file in their applications when using SDK tools to
       provide for portability between releases of SDK, and platforms
       supported by SDK.

*****************************************************************************/

#ifndef SDK
#define SDK


/****************************************************************************/
/*  GLOBAL DEFINES  */
/****************************************************************************/

#define BAD                0x00     /* BAD return state */
#define ERROR              0x01     /* ERROR return state */
#define EXIT_ABNORMAL      0x00     /* abnormal exit status */
#define EXIT_NORMAL        0xff     /* normal exit status */
#ifndef FALSE
#define FALSE              0x00     /* FALSE return state */
#endif
#define GOOD               0xff     /* GOOD return state */
#define MAX_SIZESTRING     4096     /* maximum size of string */
#define RETURN_ABNORMAL    0x00     /* abnormal return status */
#define RETURN_NORMAL      0xff     /* normal return status */
#ifndef TRUE
#define TRUE               0xff     /* TRUE return state */
#endif

/*  THIS DEFINES A FUNCTION WHICH RETURNS A COUNT OF ELEMENTS IN AN ARRAY  */

#define ELEMENTS(x)        (sizeof(x)/sizeof(x[0]))
#define Spoint(pt, x, y, z) pt[0] = (x); pt[1] = (y); pt[2] = (z)


/*  THIS DEFINES A FUNCTION FOR PROTOTYPE DEFINITION  */

#ifdef PROTOTYPES
#define _(x)               x        /* prototype definition */
#else
#define _(x)               ()       /* non-prototype definition */
#endif


/****************************************************************************/
/*  GLOBAL TYPEDEFS  */
/****************************************************************************/

typedef unsigned char    byte;      /* byte definition */
typedef unsigned char    uchar;     /* unsigned character */

#ifndef OEL
typedef unsigned int     uint;      /* unsigned integer */
typedef unsigned short   ushort;    /* unsigned short integer */
#endif

typedef unsigned short   word;      /* word definition */
typedef unsigned long    ulong;     /* unsigned long integer */


/****************************************************************************/
/*  ADS TYPEDEFS  */
/****************************************************************************/

typedef char ads_enthandle[17];     /* entity handle for ADS */

#endif                              /* SDK */
