/*\
 *  Embeded C++ Watcom SQL Database core header file
 *  $Id:$
\*/ 

#ifndef _DBCORE_HPP_INCLUDED

#ifndef __cplusplus
#error dbcore.hpp is for use with C++
#endif

#include <string.hpp>

#undef TRUE
#undef FALSE
/** {secret} **/
#define TRUE 1
/** {secret} **/
#define FALSE 0


/** {secret} **/
typedef int             BOOL;   // BOOLean (0 or !=0)

#pragma warning 594 5
#pragma warning 604 5

/**
 ** Dostop do zunanje baze podatkov se vr"sijo preko razreda Database
 **/
class Database
{
public:
  Database ();

  virtual BOOL Open (const char *userName, const char *password, 
                     const char *startStr);
  virtual void Close ();

public:
  BOOL IsOpen ();
  BOOL CanUpdate ();
  BOOL CanTransact ();

  const char * GetDatabaseName ();

public:
  void SetLoginTimeOut (int seconds);
  void SetQueryTimeout (int seconds);

  BOOL Commit();
  BOOL Rollback();
  BOOL BeginSubTrans();
  BOOL EndSubTrans();
  BOOL RollbackSubTrans();

  BOOL ExecuteSQL (const char *sqlStm);

protected:
  short DBOpen;   
  friend class FieldExchange;
  friend class Recordset;
  friend class DBException;

public:
void Database::SetErrorHandler (void (* userHandler) (int));

private:
  static void (*ErrorHandler) (int err);

};

/** {secret} */
#define _DBCORE_HPP_INCLUDED
#endif

