/*\ 
 *     PRIVATE PROFILE STRINGS - DDJ9403 pp 91-92 
 *     $Id: PROFPORT.H 1.1 1995/01/16 12:13:05 leon Exp $
\*/

#ifndef _PROFPORT_H_INCLUDED
#ifdef __cplusplus
extern "C" {
#endif

#define MAX_LINE_LENGTH 80

int get_private_profile_int (char *section, char *entry, 
                                int def, char *file_name);
int get_private_profile_string (char *section, char *entry, char *def, 
                char *buffer, int buffer_len, char *file_name);
int write_private_profile_string (char *section, char *entry, 
                                char *buffer, char *file_name);


#ifdef WINDOWS
#define getIniString(section, entry, def, buffer)  \   
        GetPrivateProfileString(section, entry, def, \           
                buffer, sizeof(buffer) - 1, IniFile)

#define getIniInt(section, entry, def)  \   
        GetPrivateProfileInt(section, entry, def, IniFile)

#define writeIniString(section, entry, buffer)  \
   WritePrivateProfileString(section, entry, buffer, IniFile)
#else
#define getIniString(section, entry, def, buffer)  get_private_profile_string(section, entry, def, buffer, sizeof(buffer) - 1, IniFile)

#define getIniInt(section, entry, def)  \   
        get_private_profile_int(section, entry, def, IniFile)

#define writeIniString(section, entry, buffer) write_private_profile_string(section, entry, buffer, IniFile)
#endif

#define _PROFPORT_H_INCLUDED
#ifdef __cplusplus
}
#endif
#endif
