//
// Sample STL program to show how to iterate thru list of list's.
//
#include <stl.h>
#include <iostream.h>

//
// convenience typedefs to save typing.
//
typedef list<int> List;
typedef list<List> ListOfList;

void print_list(const List& list1, int id) {
    ostream_iterator<int> out(cout, " ");
    cout << "list " << id << ": ";
    copy(list1.begin(), list1.end(), out);
    cout << endl;
}

int main () {
    ListOfList list_of_list1;

    //
    // create the list of list: total of 3 lists, each with 4 members.
    //
    for(int i = 0; i < 3; ++i) {
        List list1;
        for(int j = 0; j < 4; ++j) {
            list1.push_back(i * 4 + j);
        }
        print_list(list1, i+1);
        list_of_list1.push_back(list1);
    }

    cout << endl;

    //
    // now iterator thru list of lists.
    //
    ListOfList::iterator it = list_of_list1.begin();
    for(int j = 1; it != list_of_list1.end(); ++it, ++j) {
        const List& list1 = *it;
        print_list(list1, j);
    }

    return 0;
}

